/* GenMI2SI_main.cpp generated on Wed Dec 07 13:18:05 2005
 */

#include "GenMI2SI.h"
#include "InputFileRegistry.h"
UDM_USE_DOM
UDM_USE_MGA

// Extern global temporary root object(s).
void usage()
{
	std::cout << "Usage:  NewBlock.exe UMLFileType=\"model\\myUML.mga\"!\"Udm\\\"  JavaFileType=\"model\\myOutput.mga\"!\"Udm\\\"  or\n\tNewBlock -d\n\n";
}

int main( int argc, char* argv[])
{
	InputFileRegistry ifr;
	ifr.registerFile( "UMLFileType=\"model\\myUML.mga\"!\"Udm\\\" ");
	ifr.registerFile( "JavaFileType=\"model\\myOutput.mga\"!\"Udm\\\" ");
	if( argc== 1)
	{
		usage( );
		return -1;
	}
	else
		if( ( argc== 2)&& ( std::string( argv[ 1])== "-d"))
			std::cout << "Executing with default arguments." << std::endl;
		else
			for( int i= 1; i<argc; ++i)
			{
				if( false== ifr.registerFile( argv[ i]))
					throw InputFileEx( std::string( "Invalid input file expression: ") + argv[ i]);
			}
	try
	{
		std::vector< Udm::StaticDataNetworkSpecifier> dnsvec;
		// Open JavaFileType w
		Udm::SmartDataNetwork sdnJavaModel_17d( JavaModel::diagram);
		sdnJavaModel_17d.CreateNew( ifr.getFileName( "JavaFileType"), UseXSD()( ifr.getFileName( "JavaFileType")) ? ifr.getXsdName( "JavaFileType") : "JavaModel", JavaModel::RootFolder::meta, Udm::CHANGES_LOST_DEFAULT);
		Udm::StaticDataNetworkSpecifier sdns_JavaModel_17e( ifr.getFileName( "JavaFileType"), &sdnJavaModel_17d);
		dnsvec.push_back( sdns_JavaModel_17e);
		// Open UMLFileType r
		Udm::SmartDataNetwork sdnUMLModel_17a( UMLModel::diagram);
		sdnUMLModel_17a.OpenExisting( ifr.getFileName( "UMLFileType"), UseXSD()( ifr.getFileName( "UMLFileType")) ? ifr.getXsdName( "UMLFileType") : "UMLModel", Udm::CHANGES_LOST_DEFAULT);
		Udm::StaticDataNetworkSpecifier sdns_UMLModel_17b( ifr.getFileName( "UMLFileType"), &sdnUMLModel_17a);
		dnsvec.push_back( sdns_UMLModel_17b);
		// Create the project
		Udm::StaticUdmProject prj( dnsvec, MI2SI::diagram);
		Udm::DataNetwork& javaModel_ref_17f= prj.GetDataNetwork( ifr.getFileName( "JavaFileType"));
		Udm::DataNetwork& uMLModel_ref_17c= prj.GetDataNetwork( ifr.getFileName( "UMLFileType"));
		Packets_t javaIns_1;
		Packets_t uMLIns_3;
		// get objects from DNs
		UMLModel::RootFolder rootUMLModel_180= UMLModel::RootFolder::Cast( uMLModel_ref_17c.GetRootObject());
		JavaModel::RootFolder rootJavaModel_181= JavaModel::RootFolder::Cast( javaModel_ref_17f.GetRootObject());
		// Add objects to input packets.
		javaIns_1.push_back( rootJavaModel_181);
		uMLIns_3.push_back( rootUMLModel_180);
		// Get access to temporary root object(s).
		// transformation
		NewBlock_0 newBlock_0;
		newBlock_0( javaIns_1, uMLIns_3);
		// Close the project
		prj.Close();
		// Close JavaFileType w
		sdnJavaModel_17d.CloseWithUpdate();
		// Close UMLFileType r
		sdnUMLModel_17a.CloseNoUpdate();
	}
	catch( udm_exception &e)
	{
		cout << e.what() << endl;
	}
	return 0;
}

